Turbine.Chat.Received = function(sender,args)

  if args.ChatType == Turbine.ChatType.PlayerCombat
  or args.ChatType == Turbine.ChatType.EnemyCombat then
    return
  end

  ------------ points
	if args.ChatType == Turbine.ChatType.Advancement and
	string.find(args.Message,L.Chat_Earned) and
	string.find(args.Message,L.Chat_Points) then

    local current_date = Turbine.Engine.GetDate()
		local now = GetSecondsOfYear()
		local points_gained = tonumber(string.match(args.Message, L.Chat_Earned.."(%d+)"..L.Chat_Points))

		if new_fight1 then
			new_fight1 = false
			points_last_fight = 0
		end

		if (local_player:IsInCombat() or local_player:GetMorale() == nil) then
			points_last_fight = points_last_fight + points_gained
		end

		data.numbers.points_current_day = data.numbers.points_current_day + points_gained
		data.numbers.points_total = data.numbers.points_total + points_gained
		data.numbers.recent_points[now] = (data.numbers.recent_points[now] or 0) + points_gained

		overviewWindow:Update()

    if data.numbers.points_current_day >= data.numbers.most_points_a_day[1] then
      data.numbers.most_points_a_day = { data.numbers.points_current_day, current_date.Day, current_date.Month, current_date.Year }
    end

		Plugins["PvMP+"].Unload()
    
  ------------ commendations
  elseif args.ChatType == Turbine.ChatType.Standard and
	string.find(args.Message,L.Chat_Earned_Comms) and
	string.find(args.Message,L.Chat_Commendations) then
  
    local current_date = Turbine.Engine.GetDate()
		local now = GetSecondsOfYear()
		local comms_gained = tonumber(string.match(args.Message, L.Chat_Earned_Comms.."(%d+)"..L.Chat_Commendations))

		if new_fight2 then
			new_fight2 = false
			comms_last_fight = 0
		end

		if (local_player:IsInCombat() or local_player:GetMorale() == nil) then
			comms_last_fight = comms_last_fight + comms_gained
		end

		data.numbers.comms_current_day = data.numbers.comms_current_day + comms_gained
		data.numbers.recent_comms[now] = (data.numbers.recent_comms[now] or 0) + comms_gained

		overviewWindow:Update()

    Plugins["PvMP+"].Unload()

  ------------ tracks
  elseif args.ChatType == Turbine.ChatType.Standard and
  string.find(args.Message,L.Track) then
  
    if not storage.track_warning_disabled then trackCounter = 2 end
    local now = GetSecondsOfYear()

    data.numbers.tracks_current_day = data.numbers.tracks_current_day + 1
    data.numbers.recent_tracks[now] = (data.numbers.recent_tracks[now] or 0) + 1
    data.numbers.tracks_total = data.numbers.tracks_total + 1
    Plugins["PvMP+"].Unload()

  ------------ killing blows
	elseif args.ChatType == Turbine.ChatType.Death and
  string.find(args.Message,L.FragStart) and
  string.find(args.Message,L.FragEnd) then

    local current_date = Turbine.Engine.GetDate()
    local victim = string.match(args.Message, L.FragStart.."(%a+)"..L.FragEnd)
    local now = GetSecondsOfYear()

    data.numbers.frags_current_day = data.numbers.frags_current_day + 1
    data.numbers.recent_frags[now] = (data.numbers.recent_frags[now] or 0) + 1
    data.numbers.frags[victim] = (data.numbers.frags[victim] or 0) + 1

    if data.numbers.frags_current_day >= data.numbers.most_frags_a_day[1] then
      data.numbers.most_frags_a_day = { data.numbers.frags_current_day, current_date.Day, current_date.Month, current_date.Year }
    end
    
    secondaryWindow:NewRecentKill(victim)
    
    Plugins["PvMP+"].Unload()

  ------------ other's position
  elseif string.find(args.Message, positionPattern) then
    local player, amount, s, w = string.match(args.Message, positionPattern)
  
    if amount == "" then amount = "?" end
    
    if locale == "de" or locale == "fr" or locale == "ru" then
      w=tonumber((string.gsub(w,"%.",",")))
      s=tonumber((string.gsub(s,"%.",",")))
    end
    
    mapWindow:AddEnemyPosition(w, s, amount, string.sub(player,32, string.len(player)-9))

  ------------ position
  elseif args.ChatType == Turbine.ChatType.Standard and
  string.find(args.Message, L.locationString) then
  
    local region, lx, ly, ox, oy, oz, heading
    if string.find(args.Message, L.headingString) == nil then
      -- there is a carriage return at the end of the message :(
      heading=0
      region, lx, ly, ox, oy, oz = string.match(args.Message, L.patternString1)
      if region==nil then
        --You are at: r1 lx1984 ly1536 cInside ox105.19 oy-11.28 oz-56.47 h129.4
				region, lx, ly, ox, oy, oz, heading = string.match(args.Message, L.patternString2)
				if region==nil then
					region, lx, ly, i, ox, oy, oz, heading = string.match(args.Message, L.patternString3)
					if region==nil then
						region, lx, ly, i, ox, oy, oz, heading = string.match(args.Message, L.patternString4)
					end
				end
			end
		else
			region, lx, ly, ox, oy, oz, heading = string.match(args.Message, L.patternString1.." h(%d+%.?%d*)")
			if region==nil then
				--You are at: r1 lx1984 ly1536 cInside ox105.19 oy-11.28 oz-56.47 h129.4
				region, lx, ly, ox, oy, oz, heading = string.match(args.Message, L.patternString2.." h(%d+%.?%d*)")
				if region==nil then
					region, lx, ly, i, ox, oy, oz, heading = string.match(args.Message, L.patternString3.." h(%d+%.?%d*)")
					if region==nil then
						region, lx, ly, i, ox, oy, oz, heading = string.match(args.Message, L.patternString4.." h(%d+%.?%d*).*")
					end
				end
			end
    end

		if region ~= nil then
    
			if heading == nil then heading = 0 end

			if locale == "de" or locale == "fr" or locale == "ru" then
				ox=tonumber((string.gsub(ox,"%.",",")))
				oy=tonumber((string.gsub(oy,"%.",",")))
				oz=tonumber((string.gsub(oz,"%.",",")))
				heading=tonumber((string.gsub(heading,"%.",",")))
			end

			local ew, ns = (( math.floor( lx / 8 ) * 160 + ox ) - 29360) / -200, (( math.floor( ly / 8 ) * 160 + oy ) - 24880) / -200
      mapWindow:MoveCurrentPosition(ew, ns, heading)

    end
  end
end

FormatPoints = function(points)
	local temp = tostring(points)
	local temp_length = string.len(temp)
	
	if temp_length == 4 then
		temp = string.sub(temp,1,1) .. "." .. string.sub(temp,2)
	elseif temp_length == 5 then
		temp = string.sub(temp,1,2) .. "." .. string.sub(temp,3)
	elseif temp_length == 6 then
		temp = string.sub(temp,1,3) .. "." .. string.sub(temp,4)
	elseif temp_length == 7 then
		temp = string.sub(temp,1,1) .. "." .. string.sub(temp,2,4) .. "." .. string.sub(temp,5)
	end
	
	return temp
end