TrackWarningWindow = class(Turbine.UI.Window)
 
function TrackWarningWindow:Constructor()

  Turbine.UI.Window.Constructor(self)
  local width = 400
  local height = 90
	self:SetSize(width,height)
  self:SetPosition(data.numbers.trackWarning_x,data.numbers.trackWarning_y)

  self:SetWantsKeyEvents(true)
  self:SetMouseVisible(false)
  self:SetVisible(true)
  
  self.DragBar = DragBar(self, L.TrackWarning)

 	self.track_warning_label = Turbine.UI.Label()
  self.track_warning_label:SetParent(self)
  self.track_warning_label:SetSize(width,height - 20)
  self.track_warning_label:SetForeColor(Turbine.UI.Color(1,.2,.2))
	self.track_warning_label:SetPosition(0,0)
	self.track_warning_label:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
  self.track_warning_label:SetFont(Turbine.UI.Lotro.Font.TrajanProBold30)
	self.track_warning_label:SetFontStyle(Turbine.UI.FontStyle.Outline)
  self.track_warning_label:SetText(L.Track_Message)
	self.track_warning_label:SetMouseVisible(false)
  self.track_warning_label:SetVisible(false)

  self.PositionChanged = function(sender, args)
		data.numbers.trackWarning_x = self:GetLeft()
		data.numbers.trackWarning_y = self:GetTop()
  end
  
end